#!/bin/sh

case "$1" in
    install)
		#create directories
		if [ ! -d /var/ipfire/forward ]; then
			mkdir /var/ipfire/forward
			mkdir /var/ipfire/forward/bin
		fi
			
		if [ ! -d /var/ipfire/fwhosts ]; then
			mkdir /var/ipfire/fwhosts
		fi
			
		#backup org.files
		echo "Back up org files..."
		mv /var/ipfire/langs/de.pl /var/ipfire/langs/de.pl-org
		mv /var/ipfire/langs/en.pl /var/ipfire/langs/en.pl-org
		mv /var/ipfire/menu.d/50-firewall.menu /var/ipfire/menu.d/50-firewall.menu-org
		mv /var/ipfire/general-functions.pl /var/ipfire/general-functions.pl-org
		mv /etc/init.d/firewall /etc/init.d/firewall-org
		#copy files
		echo "copying new files..."
		cp files/forwardfw.cgi /srv/web/ipfire/cgi-bin/
		cp files/fwhosts.cgi /srv/web/ipfire/cgi-bin/
		cp files/de.pl /var/ipfire/langs/
		cp files/en.pl /var/ipfire/langs/
		cp files/rules.pl /var/ipfire/forward/bin/
		cp files/firewall-lib.pl /var/ipfire/forward/bin/
		cp files/icmp-types /var/ipfire/fwhosts/
		cp files/forwardfwctrl /usr/local/bin/
		cp files/50-firewall.menu /var/ipfire/menu.d/
		cp files/general-functions.pl /var/ipfire/
		cp files/firewall /etc/init.d/firewall
		
		#create empty files
		echo "creating empty files..."
		touch /var/ipfire/forward/config
		touch /var/ipfire/forward/input
		touch /var/ipfire/forward/settings
		touch /var/ipfire/fwhosts/customgroups
		touch /var/ipfire/fwhosts/customhosts
		touch /var/ipfire/fwhosts/customnetworks
		touch /var/ipfire/fwhosts/customservicegrp
		touch /var/ipfire/fwhosts/customservices
		
		#fix permissions
		echo "Fixing permissions..."
		chown -R nobody:nobody /var/ipfire/forward
		chown -R nobody:nobody /var/ipfire/fwhosts
		chown -R root:nobody /usr/local/bin/forwardfwctrl
		chmod 755 /usr/local/bin/forwardfwctrl
		chmod +s /usr/local/bin/forwardfwctrl
		chmod 755 /var/ipfire/forward/bin/rules.pl
		chmod 755 /srv/web/ipfire/cgi-bin/forwardfw.cgi
		chmod 755 /srv/web/ipfire/cgi-bin/fwhosts.cgi
		echo "Regenerating Language cache..."
		perl -e "require '//var/ipfire/lang.pl'; &Lang::BuildCacheLang"
		
		iptables -N FORWARDFW
		iptables -A FORWARD -j FORWARDFW
		
		iptables -N INPUTFW
		iptables -A INPUT -m state --state NEW -j INPUTFW
		
		echo "------------------------------------All done... you can now test the firewall"
		;;
deinstall)
		rm -rf /var/ipfire/forward
		rm -rf /var/ipfire/fwhosts
		rm /usr/local/bin/forwardfwctrl
		mv /var/ipfire/langs/de.pl-org /var/ipfire/langs/de.pl
		mv /var/ipfire/langs/en.pl-org /var/ipfire/langs/en.pl
		mv /var/ipfire/general-functions.pl-org /var/ipfire/general-functions.pl
		mv /var/ipfire/menu.d/50-firewall.menu-org /var/ipfire/menu.d/50-firewall.menu
		mv /etc/init.d/firewall-org /etc/init.d/firewall
		perl -e "require '//var/ipfire/lang.pl'; &Lang::BuildCacheLang"
		echo "System cleaned up... Firewall deinstalled"
		;;
*)
		echo "Usage: $0 {install|deinstall}"
        exit 1
        ;;
esac

